#ifndef ETHERLIB_DYNMEM_H
#define ETHERLIB_DYNMEM_H

#include <stdint.h>

/**
 * Initialize EtherLib dynamic memory management subsystem,
 * based on heap pointer and size given in etherlib_options.h
 */
void dynmem_init();

/**
 * Dynamically allocate memory from EtherLib's pool.
 * @param size requested size
 * @return pointer to allocated area or NULL on failure
 */
void * dynmem_alloc(uint32_t size);

/**
 * Release allocated block.
 * @param ptr pointer to allocated area
 */
void dynmem_free(void * ptr);

#endif //ETHERLIB_DYNMEM_H
