#ifndef ETHERLIB_GLOBAL_STATE_H
#define ETHERLIB_GLOBAL_STATE_H

#include "memory_pool.h"
#include "packet_registry.h"
#include "packet_sieve.h"
#include "eth_interface.h"

/**
 * Global EtherLib state.
 */
typedef struct {
    MP * mp; ///< Memory pool for dynamic allocations
    PcktRegistry * pcktReg; ///< Packet registry
    EthInterface * ethIntf; ///< Array of Ethernet interfaces
} EthState;

extern EthState gEthState;
#define E (gEthState)

/**
 * Initialize EthLib.
 */
void ethlib_init();

void process_raw_packet(const uint8_t * data, uint32_t size);

#endif //ETHERLIB_GLOBAL_STATE_H
